<?php
/**
 * The Header for our theme.
 *
 * Displays all of the <head> section and everything up till <div id="main">
 *
 * @package WordPress
 * @subpackage Twenty_Ten
 * @since Twenty Ten 1.0
 */
?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged;

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'twentyten' ), max( $paged, $page ) );

	?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
<script type='text/javascript' src='<?php bloginfo('template_directory'); ?>/scripts/custom.js'></script>
<!--<script type='text/javascript' src='http://apis.google.com/js/plusone.js'></script>-->
<script type='text/javascript' src='<?php bloginfo('template_directory'); ?>/scripts/cufon/cufon-1.10.min.js' type='text/javascript'></script>
<script type='text/javascript' src='<?php bloginfo('template_directory'); ?>/scripts/cufon/bifon-1.0b.js'     type='text/javascript'></script>
<script type='text/javascript' src='<?php bloginfo('template_directory'); ?>/scripts/cufon/Cb.js'          type='text/javascript'></script>
<script type="text/javascript">

  Cufon.replace('#content h2 span', {onBeforeReplace:Bifon.convert});
  Cufon.replace('#content h1 span', {onBeforeReplace:Bifon.convert});
  Cufon.replace('#author-description h2', {onBeforeReplace:Bifon.convert});
  Cufon.replace('#wp_thumbie_rl1 h3', {onBeforeReplace:Bifon.convert});
  Cufon.replace('#comments-title', {onBeforeReplace:Bifon.convert});
  Cufon.replace('h2.author2', {onBeforeReplace:Bifon.convert});

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-20400688-1']);
  _gaq.push(['_setDomainName', 'averta.net']);
  _gaq.push(['_setAllowHash', false]);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>
<?php
	/* We add some JavaScript to pages with the comment form
	 * to support sites with threaded comments (when in use).
	 */
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );

	/* Always have wp_head() just before the closing </head>
	 * tag of your theme, or you will break many plugins, which
	 * generally use this hook to add elements to <head> such
	 * as styles, scripts, and meta tags.
	 */
	wp_head();
?>
<link rel="stylesheet" type="text/css" media="all" href='<?php bloginfo('template_directory'); ?>/override-style.css'    />
</head>

<body <?php body_class(); ?>  onload="setValue()">

<div id="header">
		<div id="masthead">
			<div id="branding" role="banner">
				<?php $heading_tag = ( is_home() || is_front_page() ) ? 'h1' : 'div'; ?>
<<?php echo $heading_tag; ?> id="site-title">
					<span>
						<a href="<?php echo home_url( '/' ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home">  <img src="<?php bloginfo('template_directory'); ?>/styles/images/logo.jpg"  alt="<?php bloginfo( 'name' ); ?>" />    </a>
					</span>
				</<?php echo $heading_tag; ?>>
				<div id="site-description">
<?php /* :mj: bloginfo( 'description' ); */ ?>
					<a href="http://www.facebook.com/pages/%D8%A7%D9%8E%D9%88%D9%90%D8%B1%D8%AA%D8%A7/270717232964163?sk=wall" title="Facebook" ><img src="<?php bloginfo('template_directory'); ?>/styles/images/facebook.jpg"  alt="Follow us on Facebook" ><a/>
					<a href="http://www.twitter.com/averta" title="Follow Us on Twiiter" ><img src="<?php bloginfo('template_directory'); ?>/styles/images/twitter.jpg"   alt="Follow us on Twitter"  ><a/>
					<a href="<?php echo home_url( '/' ); ?>?feed=rss2" title="subscribe " ><img src="<?php bloginfo('template_directory'); ?>/styles/images/rss.jpg"   alt="subscribe to Rss"  ><a/>
				</div>
<?php /* :mj: slider here */ ?>
			</div><!-- #branding -->
			
			<div id="access" role="navigation">
				<div class="skip-link screen-reader-text"><a href="#content" title="<?php esc_attr_e( 'Skip to content', 'twentyten' ); ?>"><?php _e( 'Skip to content', 'twentyten' ); ?></a></div>
				<?php wp_nav_menu( array( 'container_class' => 'menu-header', 'theme_location' => 'primary' ) ); ?>
			</div><!-- #access -->
			
		</div><!-- #masthead -->
</div><!-- #header -->


<div id="wrapper" class="hfeed">
	<div id="main">